
import 'package:buzz_repo/models/repo_path.dart';
import 'package:buzz_result/models/result.dart';

import '../models/ids.dart';
import 'json_object.dart';

abstract class LocalDb<T> {
  LocalDb();
  Future init();
  bool get isInitialized;
  Future close();
  Future<LocalDb> ofTable<T>(String table);
  Future<LocalDb> ofPath<T>(List<LocalRepoPath> path);
  Future<int?> add<T>(JsonObject object);
  Future<Result<T>> update<T>(JsonObject object);
  Future<Result<T>> get<T>(IDs ids);
  Future<Result<List<T>>> getAll<T>();
  Future<Result> delete(IDs ids);
}
